<?php
/*
Plugin Name: Weighted Categories - local customized
Plugin URI: http://hitormiss.org/archives/2004/12/20/weighted-categories-list-in-wordpress/
Description: Template tag to display a weighted list of category links
Version: 1.2-local
Author: Matt Kingston - customized by charkee
Author URI: http://www.hitormiss.org/
*/
function weighted_categories($minlevel=1, $maxlevel=10, $exclude='')
{
	$cats = list_cats(1, 'all', 'name', 'asc', '', 0, 0, 1, 1, 0, 1, 1, 0, 1, '', '', $exclude, 0);

	$cats = explode("\n", $cats);
	foreach ($cats as $cat)
	{
		$cat = trim($cat);
		if ($cat) {
			if (preg_match('/<a href="([^"]+)" title="[^"]*">(\w+)<\/a> \((\d+)\)/i', $cat, $regs)) {
				$catlink = $regs[1];
				$catname = $regs[2];
				$count = $regs[3];
				$counts{$catname} = $count;
				$catlinks{$catname} = $catlink;
			}
		}
	}
	$spread = max($counts) - min($counts); 
	if ($spread <= 0) { $spread = 1; };
	$levelspread = $maxlevel - $minlevel;
	$levelstep = $spread / $levelspread;
	if ($levelspread <= 0) { $levelspread = 1; }
	foreach ($counts as $catname => $count)
	{
		$catlink = $catlinks{$catname};
		print "<a href=\"$catlink\" title=\"$count 篇文章\" class=\"taglevel".
		floor($minlevel + ($count/$levelstep))."\">$catname</a> \n";
	}
}
?>

